.\" Copyright (c) 1999 Doug White
.\" All rights reserved.
.\"
.\" Redistribution and use in source and binary forms, with or without
.\" modification, are permitted provided that the following conditions
.\" are met:
.\" 1. Redistributions of source code must retain the above copyright
.\"    notice, this list of conditions and the following disclaimer.
.\" 2. Redistributions in binary form must reproduce the above copyright
.\"    notice, this list of conditions and the following disclaimer in the
.\"    documentation and/or other materials provided with the distribution.
.\"
.\" THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
.\" ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
.\" IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
.\" ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
.\" FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
.\" DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
.\" OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
.\" HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
.\" LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
.\" OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
.\" SUCH DAMAGE.
.\"
.\" $FreeBSD: src/sys/boot/i386/pxeldr/pxeboot.8,v 1.7 2002/12/12 17:25:59 ru Exp $
.\" $DragonFly: src/sys/boot/pc32/pxeldr_tftp/pxeboot_tftp.8,v 1.3 2007/11/21 19:12:41 swildner Exp $
.\"
.\" Note: The date here should be updated whenever a non-trivial
.\" change is made to the manual page.
.Dd May 1, 2000
.Dt PXEBOOT_TFTP 8
.Os
.Sh NAME
.Nm pxeboot_tftp
.Nd Preboot Execution Environment (PXE) bootloader using TFTP
.Sh DESCRIPTION
The
.Nm
bootloader is a modified version of the system third-stage bootstrap
.Xr loader 8
configured to run under Intel's Preboot Execution Environment (PXE) system.
PXE is a form of smart boot ROM, built into Intel EtherExpress Pro/100 and
3Com 3c905c Ethernet cards, and Ethernet-equipped Intel motherboards.
PXE supports DHCP configuration and provides low-level NIC access services.
The
.Nm
bootloader retrieves the kernel, modules, and other files via TFTP.
In combination with a NFS-mounted root file system,
.Nm
allows for easy,
EEPROM-burner free construction of diskless machines.
.Pp
The
.Nm
binary is loaded just like any other boot file,
by specifying it in the DHCP server's configuration file.
Below is a sample configuration for the ISC DHCP v2 server:
.Bd -literal -offset indent
option domain-name "example.com";
option routers 10.0.0.1;
option subnet-mask 255.255.255.0;
option broadcast-address 10.0.0.255;
option domain-name-servers 10.0.0.1;
server-name "DHCPserver";
server-identifier 10.0.0.1;

default-lease-time 120;
max-lease-time 120;

subnet 10.0.0.0 netmask 255.255.255.0 {
       filename "pxeboot_tftp";
       range 10.0.0.10 10.0.0.254;
}

.Ed
.Nm
recognizes
.Va next-server
and
.Va option root-path
directives as the server and path to NFS mount for file requests,
respectively, or the server to make TFTP requests to.
Note that
.Nm
expects to fetch
.Pa /boot/loader.rc
from the specified server before loading any other files.
.Pp
In all other respects,
.Nm
acts just like
.Xr loader 8 .
.Pp
As PXE is still in its infancy, some firmware versions may not work
properly.
The
.Nm
bootloader has been extensively tested on version 0.99 of Intel firmware;
pre-release versions of the newer 2.0 firmware are known to have
problems.
Check with the device's manufacturer for their latest stable release.
.Pp
For further information on Intel's PXE specifications and Wired for
Management (WfM) systems, see
.Pa http://developer.intel.com/ial/wfm/ .
.Sh SEE ALSO
.Xr loader 8 ,
.Xr pxeboot 8
.Sh HISTORY
The
.Nm
bootloader first appeared in
.Fx 4.1 .
.Sh AUTHORS
.An -nosplit
The
.Nm
bootloader was written by
.An John Baldwin Aq jhb@FreeBSD.org
and
.An Paul Saab Aq ps@FreeBSD.org .
This manual page was written by
.An Doug White Aq dwhite@FreeBSD.org .
